unit Demo1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons, ExtCtrls, RptWorks, DBTables,
  DB;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    CustSource: TDataSource;
    Cust: TTable;
    CustCustNo: TFloatField;
    CustCompany: TStringField;
    CustAddr1: TStringField;
    CustAddr2: TStringField;
    CustCity: TStringField;
    CustState: TStringField;
    CustZip: TStringField;
    CustPhone: TStringField;
    OrderSource: TDataSource;
    Orders: TTable;
    OrdersOrderNo: TFloatField;
    OrdersCustNo: TFloatField;
    OrdersPaymentMethod: TStringField;
    OrdersItemsTotal: TCurrencyField;
    OrdersAmountPaid: TCurrencyField;
    PrintDialog1: TPrintDialog;
    Panel2: TPanel;
    Image1: TImage;
    Memo1: TMemo;
    Button1: TButton;
    Button3: TButton;
    Button4: TButton;
    BitBtn2: TBitBtn;
    Button5: TButton;
    BitBtn1: TBitBtn;
    Button2: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel1: TPanel;
    Bevel1: TBevel;
    Label1: TLabel;
    Bevel2: TBevel;
    Label5: TLabel;
    ReportWorks1: TReportWorks;
    procedure FormShow(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private declarations }
    procedure PrintHeader;
    procedure PrintReport;
    procedure UpdatePageStatus;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  ABuffer:pchar;

implementation

{$R *.DFM}


procedure TForm1.UpdatePageStatus;
begin
  {Update current report page.}
  Label1.Caption := 'Page ' + IntToStr(ReportWorks1.CurrentPage)
                    + ' of ' + IntToStr(ReportWorks1.PageTotal);
  Label5.Caption := 'Zoom : ' + IntToStr(ReportWorks1.ZoomPercent) + '%';
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  {Set range - don't need all database.}
  Cust.SetRange([1220],[1512]);
  {Print the report to the screen.}
  PrintReport;
end;

procedure TForm1.PrintReport;
var x:integer;
    TotalMiles,TotalGas:integer;
    shade:boolean;
    tmpstr:string;
begin
{Get bitmap, if it exists.}
with ReportWorks1 do
  begin
  {Margins change later so make sure they are set
   properly on future calls.}
  LeftMargin := 1;
  RightMargin := 1;
  if Destination = dPreview then Screen.Cursor := crHourGlass;
  StartDoc;
  SetTab(1.25,jLeft);
  PositionGraphic(jCenter,Image1.Picture);
  for x := 1 to 8 do NextLine;
  SetFont('Arial',14);
  Print('Technical Report');
  NextLine;
  NextLine;
  DrawLIne;
  NextLine;
  SetFont('Arial',10);
  Print('To:');
  PrintTab(1,'Delphi Programmer');
  NextLine;
  Print('From:');
  PrintTab(1,'HSoftWare');
  NextLine;
  Print('Product:');
  PrintTab(1,'ReportWorks Component');
  NextLine;
  Print('Version:');
  PrintTab(1,'1.10');
  NextLine;
  Print('Author:');
  PrintTab(1,'Howard S. Walsh');
  NextLine;
  Print('Features:');
  PrintTab(1,'Plenty');
  NextLine;
  Print('   Preview:');
  PrintTab(1,'Yes');
  NextLine;
  Print('   Status Screen:');
  PrintTab(1,'Yes');
  NextLine;
  Print('   Demo:');
  PrintTab(1,'Yes');
  NextLine;
  Print('Date:');
  PrintTab(1,DateToStr(Date));
  NextLine;
  Print('Subject:');
  FontBold;
  PrintTab(1,'Product Description');
  NextLine;
  NextLine;
  FontRegular;
  DrawLine;
  NextLine;
  NextLine;
  PrintMemo(Memo1.Lines);
  {Report page 2}
  NewPage;
  ClearTabs;
  LineWidth := lwDouble;
  DrawLine;
  NextLine;
  SetFont('Arial',16);
  PrintCenter('Car Expense Report');
  NextLine;
  NextLine;
  SetFont('Arial',12);
  FontItalic;
  PrintLeft(DateToStr(Date));
  NextLine;
  LineWidth := lwNormal;
  DrawLine;
  SetTab(1.5,jLeft);
  SetTab(4.5,jRight);
  SetTab(6.5,jRight);
  NextLine;
  FontRegular;
  FontBold;
  Print('Date');
  PrintTab(1,'Description');
  PrintTab(2,'Mileage');
  PrintTab(3,'Gas');
  FontRegular;
  NextLine;
  TotalMiles := 0;
  TotalGas := 0;
  for x := 0 to 25 do
     begin
     Print(DateToStr(Date + x));
     PrintTab(1,'Business Trip');
     PrintTab(2,IntToStr(x * 15));
     PrintTab(3,IntToStr(x * 8) + '.00');
     TotalMiles := TotalMiles + (x*15);
     TotalGas := TotalGas + (x * 8);
     NextLine;
     end;
  NextLine;
  FontBold;
  PrintTab(2,IntToStr(TotalMiles));
  PrintTab(3,IntToStr(TotalGas) + '.00');
  FontRegular;
  GoToPageBottom;
  DrawLine;
  {Report page 3}
  NewPage;
  ClearTabs;
  ShadeLine(clRed);
  DrawLine;
  NextLine;
  ShadeLine(clRed);
  NextLine;
  ShadeLine(clRed);
  PreviousLine;
  PreviousLine;
  SetFont('Arial',16);
  PrintCenter('ReportWorks Sales Report');
  NextLine;
  NextLine;
  SetFont('Arial',12);
  PrintRight(DateToStr(Date));
  NextLine;
  DrawLine;
  SetTab(1.25,jLeft);
  SetTab(3,jCenter);
  SetTab(4.5,jRight);
  SetTab(6.5,jRight);
  FontBold;
  Print('Date');
  PrintTab(1,'Software');
  PrintTab(2,'Sold');
  PrintTab(3,'Unit');
  PrintTab(4,'Price');
  FontRegular;
  NextLine;
  shade := true;
  for x := 1 to 35 do
     begin
     if shade then ShadeLine(clYellow);
     shade := not shade;
     Print(DateToStr(Date + x));
     PrintTab(1,'ReportWorks');
     PrintTab(2,IntToStr(x));
     PrintTab(3,'29.00');
     { This is just faster (easier) }
     PrintTab(4,IntToStr(x*29) + '.00');
     NextLine;
     end;
  while not IsPageEnd do
     begin
     if shade then ShadeLine(clYellow);
     shade := not shade;
     NextLine;
     end;
  {Report page 4 - MAST database demo.}
  {The ReportWorks demo program assumes you have installed the
   Delphi demo files in the default directories and that the
   Borland Database Engine is installed. If not, then this demo
   will not run unless you edit the demo source and delete
   the DataSource and Table components from the Demo1 form.
   To edit the source code, delete lines 260 to 331.}
  NewPage;
  ClearTabs;
  LeftMargin := 0.5;
  RightMargin := 0.5;
  GoToPageTop;
  {Tabs for company info.}
  SetTab(0.4,jLeft);
  SetTab(3.5,jLeft);
  SetTab(5.1,jLeft);
  SetTab(6.0,jLeft);
  SetTab(7.5,jRight);
  {Tabs for order info.}
  SetTab(1,jLeft);
  SetTab(2,jLeft);
  SetTab(4.8,jRight);
  SetTab(6.0,jRight);
  {Make sure we are on the first record.}
  Cust.First;
  PrintHeader;
  while not Cust.EOF do
     begin
     {Shade two lines.}
     ShadeLine(clBlue);
     NextLine;
     ShadeLine(clBlue);
     PreviousLine;
     {FontColor is a new procedure - undocumented in current version.}
     FontColor(clYellow);
     SetFont('Arial',8);
     Print(CustCustNo.AsString);
     SetFont('Arial',14);
     PrintTab(1,CustCompany.Value);
     SetFont('Arial',10);
     PrintTab(2,CustAddr1.Value);
     PrintTab(3,CustCity.Value);
     PrintTab(4,CustState.Value);
     PrintTab(5,CustPhone.Value + '  ');
     NextLine;
     SetFont('Arial',8);
     FontItalic;
     PrintTab(6,'Order No.');
     PrintTab(7,'Payment Method');
     PrintTab(8,'Total');
     PrintTab(9,'Amount Paid');
     NextLine;
     FontRegular;
     SetFont('Arial',10);
     if IsPageEnd then
        begin
        NewPage;
        PrintHeader;
        end;
     while not Orders.EOF do
        begin
        FontColor(clBlack);
        PrintTab(6,IntToStr(round(OrdersOrderNo.Value)));
        PrintTab(7,OrdersPaymentMethod.Value);
        Str(OrdersItemsTotal.Value:8:2,tmpstr);
        PrintTab(8,tmpstr);
        Str(OrdersAmountPaid.Value:8:2,tmpstr);
        PrintTab(9,tmpstr);
        NextLine;
        if IsPageEnd then
          begin
          NewPage;
          PrintHeader;
          end;
        Orders.Next;
        end;
     NextLine;
     Cust.Next;
     end;
  EndDoc;
  Screen.Cursor := crDefault;
  end;
UpdatePageStatus;
end;

procedure TForm1.PrintHeader;
{Header for MAST database report.}
begin
  with ReportWorks1 do
     begin
     FontBold;
     FontColor(clBlue);
     SetFont('Times Roman',42);
     Print('MAST');
     SetFont('Arial',16);
     NextLine;
     PrintRight('Marine Adventure Sales Report');
     NextLine;
     NextLine;
     ShadeLine(clBlue);
     FontColor(clYellow);
     SetFont('Arial',10);
     Print(' ReportWorks for Delphi Sample Report');
     FontItalic;
     PrintRight(DateToStr(Date)+'  ');
     FontColor(clBlack);
     FontRegular;
     NextLine;
     NextLine;
     end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ReportWorks1.NextPage;
  PrintReport;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ReportWorks1.PreviousPage;
  PrintReport
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  ReportWorks1.LastPage;
  PrintReport;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ReportWorks1.FirstPage;
  PrintReport;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
{Change destination to the printer, print report and reset destination.}
begin
  If PrintDialog1.Execute then
     begin
     if PrintDialog1.FromPage > 0 then
        ReportWorks1.PrintPageFirst := PrintDialog1.FromPage
     else ReportWorks1.PrintPageFirst := 1;
     if PrintDialog1.ToPage > 0 then
        ReportWorks1.PrintPageLast := PrintDialog1.ToPage
     else ReportWorks1.PrintPageLast := 999;
     ReportWorks1.Destination := dPrinter;
     PrintReport;
     ReportWorks1.Destination := dPreview;
     end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Screen.Cursor := crHourGlass;
  case ReportWorks1.ZoomPercent of
     40  : ReportWorks1.ZoomPercent := 100;
     60  : ReportWorks1.ZoomPercent := 40;
     75  : ReportWorks1.ZoomPercent := 60;
     100 : ReportWorks1.ZoomPercent := 75;
  end;
  PrintReport;
  Screen.Cursor := crDefault;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

end.
